// Code your design here
module alivefms (input clk, input reset, input ping, output reg ack, 
       output reg[1:0] state);
 parameter [1:0] WAIT  = 2'b11;
 parameter [1:0] PING  = 2'b01;
 parameter [1:0] ACKN  = 2'b10;
 always @(posedge clk or posedge reset or
          posedge ping or negedge ping)
 begin
  if (reset) 
  begin 
     state <= WAIT;
     ack   <= 0;
  end else
  begin
    case(state)
      WAIT:    begin
               if (ping) state <= PING;
                   else  state <= WAIT;
               ack <= 0;
               end
      PING:    if (ping) state <= PING;
                   else  state <= ACKN;
      ACKN:    begin
                ack <= 1;
                state <= WAIT;
               end
      default: state <= WAIT;
    endcase
  end
end
endmodule
