//! FPGA Particle Detector Simulation  ('golden' measure)

#include <stdio.h>
#include <stdlib.h>

int printlog = 1;  //! Debug various, set to 1 to generate log report for simulation

unsigned sclk    = 20;  // slow clock  (i.e. observation interval)
unsigned clk     = 0;   // fast clock

int detect_particle()
{   //! A dummy function to simulate input indicating particle is present

    // detecting particles when sclk%4  and clk is %4
    if (sclk%4==0) if (clk%4==0) return 1;

    return 0;
}
int detect_backscatter()
{   //! A dummy function to simulate reading an input

    // detecting backscatter particles when sclk==8  and clk is 5
    if (sclk==8) if (clk==5) return 1;

    return 0;
}

void out_tp(unsigned tp)
{
    //! simulate outputting value of tp
}

void out_fp(unsigned fp)
{
    //! simulate outputting value of fp
}

void out_fptime(unsigned time_fp)
{
    //! simulate outputting value that fp backscatter triggered
}

int main()
{
    unsigned count   = 0;   // timer counter
    unsigned time_fp = 0;
    unsigned countdown_fp = 0;
    int      backscatter = 0;
    unsigned  tp;  // number true particles
    unsigned  fp;  // number of false particles / backscatter

    if (!printlog) printf("Particle detector simulation!\n");
    if (printlog) printf("sck,clk,tp ,tp ,b,tfp\n"); // print headings out log output

    while (sclk)  // slow clock
    {
        out_tp(tp); out_fp(fp);
        out_fptime(time_fp);
        time_fp = 0;
        tp = fp = 0;
        clk=10; // fast clock
        while (clk) {
            count++;
            if (countdown_fp) {
                countdown_fp--;
                if (countdown_fp==0) backscatter = 0;
            }
            if (detect_backscatter() && (countdown_fp==0)) {
                time_fp = count;
                countdown_fp = 10;
                backscatter  = 1;
            }
            if (detect_particle()) {
                if (backscatter == 0) tp++; else fp++;
            }
            if (printlog)
              printf("%03d,%03d,%03d,%03d,%01d,%03d\n",sclk,clk,tp,fp,backscatter,time_fp);
            clk--;
        }
        sclk--;
    }
    return 0;
}
